summaryrefslogtreecommitdiff
path: root/script/trees
diff options
context:
space:
mode:
Diffstat (limited to 'script/trees')
-rwxr-xr-xscript/trees62
1 files changed, 54 insertions, 8 deletions
diff --git a/script/trees b/script/trees
index db5f52b6..ce6da422 100755
--- a/script/trees
+++ b/script/trees
@@ -12,7 +12,7 @@ set -u -e
eval `setvars "" xarch srcdir premake cmakedir xlang mode makeargs elfdir cmd \
project target target_dir targets xtree _f release bootstrapargs mkhelper \
autoconfargs listfile autogenargs btype tree rev tree_depend build_depend \
- defconfig postmake mkhelpercfg dry dest_dir`
+ defconfig postmake mkhelpercfg dry dest_dir mdir badhash`
main()
{
@@ -37,9 +37,7 @@ main()
done
[ -z "$_f" ] && $err "missing flag (-m/-u/-b/-c/-x/-f/-s/-l/-n)"
[ -z "$project" ] && for p in $(ls -1 config/git); do
- ./update trees $_f "$p" || $err "!./update trees $_f $p"
- [ "$XBMK_RELEASE" != "y" ] || singletree "$p" || \
- x_ rm -Rf "src/$p/$p"; continue
+ ./update trees $_f "$p" || $err "!./update trees $_f $p"; :
done && return 1
[ -f "config/git/$project/pkg.cfg" ] || $err "'$project' not defined"
@@ -117,7 +115,9 @@ handle_defconfig()
configure_project()
{
eval `setvars "" xarch xlang build_depend autoconfargs xtree postmake \
- tree_depend makeargs btype mkhelper bootstrapargs premake release`
+ tree_depend makeargs btype mkhelper bootstrapargs premake release \
+ badhash`
+
[ -f "$1/target.cfg" ] || btype="auto"
[ -f "$datadir/mkhelper.cfg" ] && eval `setcfg "$datadir/mkhelper.cfg"`
@@ -141,8 +141,14 @@ configure_project()
[ -z "$mode" ] && build_dependencies
+ mdir="$PWD/config/submodule/$project"
+ [ -n "$tree" ] && mdir="$mdir/$tree"
+
+ [ -f "CHANGELOG" ] || check_project_hashes
+
[ "$mode" = "fetch" ] || x_ ./update trees -f "$project" $target
[ "$mode" = "fetch" ] || return 0
+
[ -f "CHANGELOG" ] && return 1; fetch_${cmd#build_}; return 1
}
@@ -157,8 +163,48 @@ build_dependencies()
done; return 0
}
+check_project_hashes()
+{
+ mkdir -p "$XBMK_CACHE/hash" || $err "!mkdir '$XBMK_CACHE/hash'"
+
+ old_pjhash=""
+ [ ! -f "$XBMK_CACHE/hash/$project$tree" ] || \
+ read -r old_pjhash < "$XBMK_CACHE/hash/$project$tree"
+
+ x_ rm -f "$TMPDIR/project.list" "$TMPDIR/project.hash" \
+ "$TMPDIR/project.tmp"; x_ touch "$TMPDIR/project.tmp"
+ x_ touch "$TMPDIR/project.hash"
+
+ for delcheck in "$datadir" "$configdir/$tree" "$mdir"; do
+ [ -d "$delcheck" ] || continue
+ find "$delcheck" -type f -not -path "*/.git*/*" \
+ >> "$TMPDIR/project.tmp" || \
+ $err "!find $delcheck > project.tmp"
+ done
+ sort "$TMPDIR/project.tmp" > "$TMPDIR/project.list" || \
+ $err "!sort project tmp/list"
+
+ while read -r delcheck; do
+ [ -f "$delcheck" ] || continue
+ sha512sum "$delcheck" | awk '{print $1}' >> \
+ "$TMPDIR/project.hash" || $err "!findhash $delcheck"
+ done < "$TMPDIR/project.list"
+
+ pjhash="$(sha512sum "$TMPDIR/project.hash" | awk '{print $1}')" || :
+ badhash="y" && [ "$pjhash" = "$old_pjhash" ] && badhash="n"
+ [ -f "$XBMK_CACHE/hash/$project$tree" ] || badhash="y"
+
+ printf "%s\n" "$pjhash" > "$XBMK_CACHE/hash/$project$tree" || \
+ $err "!mk $XBMK_CACHE/hash/$project$tree"
+
+ [ "$badhash" = "n" ] || rm -Rf "src/$project/$tree" \
+ "elf/$project/$tree" "elf/$project/$target" || \
+ $err "!rmproject $project $tree"; :
+}
+
check_cross_compiler()
{
+ xgccargs="UPDATED_SUBMODULES=1 CPUS=$XBMK_THREADS"
for _xarch in $xarch; do
cbdir="src/coreboot/$tree"
[ "$project" != "coreboot" ] && cbdir="src/coreboot/default"
@@ -171,9 +217,9 @@ check_cross_compiler()
[ -n "$xlang" ] && export BUILD_LANGUAGES="$xlang"
# sometimes buildgcc fails for like no reason. try twice.
- make -C "$cbdir" crossgcc-${_xarch%-*} $makeargs || \
- make -C "$cbdir" crossgcc-${_xarch%-*} $makeargs || \
- $err "!mkxgcc $project/$xtree '${_xarch%-*}' '$makeargs'"
+ make -C "$cbdir" crossgcc-${_xarch%-*} $xgccargs || \
+ make -C "$cbdir" crossgcc-${_xarch%-*} $xgccargs || \
+ $err "!mkxgcc $project/$xtree '${_xarch%-*}' '$xgccargs'"
done; return 0
}